--
-- **************************************************************************
-- **************************************************************************
-- **                                                                      **
-- **                      "Ukady CPLD w praktyce"                        **
-- **                                                                      **
-- **            Module: BCD2DigCnt (przydatny komponent)                  **
-- **            Target device: XILINX CPLD                                **
-- **            Tool versions: ISE WebPACK 9.2i                           **
-- **            Date: BIAYSTOK, stycze 2009                             **
-- **                                                                      **
-- **                     Napisa : Andrzej Pawluczuk                      **
-- **                                                                      **
-- **************************************************************************
-- **************************************************************************
--
-----------------------------------------------------------------------------
library IEEE ;
use IEEE.STD_LOGIC_1164.ALL ;
use IEEE.STD_LOGIC_ARITH.ALL ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;

entity BCD2DigCnt is port ( Clk : in std_logic ;
                            Reset : in std_logic ;
                            Enable : in std_logic ;
                            Cnt1 : out std_logic_vector ( 3 downto 0 ) ;
                            Cnt10 : out std_logic_vector ( 3 downto 0 ) ) ;
end BCD2DigCnt ;

architecture Behavioral of BCD2DigCnt is

  component bcd port ( Clk : in std_logic ;
                       Reset : in std_logic ;
                       Enable : in std_logic ;
                       QOut : out std_logic_vector ( 3 downto 0 ) ) ;
  end component ;

  signal Enable10 : std_logic ;
  signal LCnt1 : std_logic_vector ( 3 downto 0 ) ;
  signal LCnt10 : std_logic_vector ( 3 downto 0 ) ;

begin
  Cnt1 <= LCnt1 ;
  Cnt10 <= LCnt10 ;

  Enable10 <= '1' when ( ( Enable = '1' ) and ( LCnt1 = "1001" ) ) else '0' ;

  BCD0Instance : bcd port map ( Clk => Clk ,
                                Reset => Reset ,
                                Enable => Enable ,
                                QOut => LCnt1 ) ;

  BCD1Instance : bcd port map ( Clk => Clk ,
                                Reset => Reset ,
                                Enable => Enable10 ,
                                QOut => LCnt10 ) ;

end Behavioral ;
