--
-- **************************************************************************
-- **************************************************************************
-- **                                                                      **
-- **                     "Ukady CPLD w praktyce"                         **
-- **                                                                      **
-- **    Project name: Pierwszy                                            **
-- **    Module: Pierwszy_tb (symulacja moduu pierwszy.vhd)               **
-- **    Target device: CoolRunner II (XC2C256/VQ100) [ZL14PLD/ZL15PLD]    **
-- **    Tool versions: ISE WebPACK 9.2i                                   **
-- **    Date: BIAYSTOK, stycze 2009                                     **
-- **                                                                      **
-- **                   Napisa : Andrzej Pawluczuk                        **
-- **                                                                      **
-- **************************************************************************
-- **************************************************************************
--
-----------------------------------------------------------------------------
library IEEE ;
use IEEE.STD_LOGIC_1164.ALL ;
use IEEE.STD_LOGIC_ARITH.ALL ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;

--USE ieee.numeric_std.ALL ;

entity pierwszy_tb_vhd is
end pierwszy_tb_vhd ;

architecture behavior of pierwszy_tb_vhd is

  component Pierwszy port ( Clk : in std_logic ;
                            Reset : in std_logic ;
                            KeyIn0 : in std_logic ;
                            KeyIn1 : in std_logic ;
                            KeyIn2 : in std_logic ;
                            KeyIn3 : in std_logic ;
                            Seg_A : out std_logic ;
                            Seg_B : out std_logic ;
                            Seg_C : out std_logic ;
                            Seg_D : out std_logic ;
                            Seg_E : out std_logic ;
                            Seg_F : out std_logic ;
                            Seg_G : out std_logic ;
                            Seg_K : out std_logic ;
                            DSel0 : out std_logic ;
                            DSel1 : out std_logic ;
                            DSel2 : out std_logic ;
                            DSel3 : out std_logic ) ;
end component ;

--Inputs
  signal Clk :  std_logic := '0' ;
  signal Reset :  std_logic := '0' ;
  signal KeyIn0 :  std_logic := '1' ;
  signal KeyIn1 :  std_logic := '1' ;
  signal KeyIn2 :  std_logic := '1' ;
  signal KeyIn3 :  std_logic := '1' ;

--Outputs
  signal Seg_A :  std_logic ;
  signal Seg_B :  std_logic ;
  signal Seg_C :  std_logic ;
  signal Seg_D :  std_logic ;
  signal Seg_E :  std_logic ;
  signal Seg_F :  std_logic ;
  signal Seg_G :  std_logic ;
  signal Seg_K :  std_logic ;
  signal DSel0 :  std_logic ;
  signal DSel1 :  std_logic ;
  signal DSel2 :  std_logic ;
  signal DSel3 :  std_logic ;

begin
-- Instantiate the Unit Under Test (UUT)
  uut : Pierwszy port map ( Clk => Clk ,
                            Reset => Reset ,
                            KeyIn0 => KeyIn0 ,
                            KeyIn1 => KeyIn1 ,
                            KeyIn2 => KeyIn2 ,
                            KeyIn3 => KeyIn3 ,
                            Seg_A => Seg_A ,
                            Seg_B => Seg_B ,
                            Seg_C => Seg_C ,
                            Seg_D => Seg_D ,
                            Seg_E => Seg_E ,
                            Seg_F => Seg_F ,
                            Seg_G => Seg_G ,
                            Seg_K => Seg_K ,
                            DSel0 => DSel0 ,
                            DSel1 => DSel1 ,
                            DSel2 => DSel2 ,
                            DSel3 => DSel3 ) ;

  tb : process
  begin
    wait for 100 ns ;
    Reset <= '0' ;
    wait for 100 ns ;
    Reset <= '1' ;
    for Inx in 0 to 118 loop
      Clk <= '1' ;
      wait for 100 ns ;
      Clk <= '0' ;
      wait for 100 ns ;
    end loop ;
    Clk <= '1' ;
    wait for 100 ns ;
    Clk <= '0' ;
    Reset <= '0' ;
    wait for 100 ns ;
    Clk <= '1' ;
    Reset <= '1' ;
    wait for 100 ns ;
    Clk <= '0' ;
    wait for 100 ns ;
    for Inx in 0 to 580 loop
      Clk <= '1' ;
      wait for 100 ns ;
      Clk <= '0' ;
      wait for 100 ns ;
    end loop ;
    KeyIn0 <= '0' ;
    for Inx in 0 to 30 loop
      Clk <= '1' ;
      wait for 100 ns ;
      Clk <= '0' ;
      wait for 100 ns ;
    end loop ;
    KeyIn0 <= '1' ;
    for Inx in 0 to 30 loop
      Clk <= '1' ;
      wait for 100 ns ;
      Clk <= '0' ;
      wait for 100 ns ;
    end loop ;
    wait ;
  end process ;

end ;
